---
- name: Assert that windows maintenance window is defined (for disk cleanup)
  ansible.builtin.assert:
    that:
      - windows_maintenance_window is defined
      - windows_maintenance_window is mapping
      - windows_maintenance_window.day_of_week is defined
      - windows_maintenance_window.day_of_week is string
      - windows_maintenance_window.hour is defined
      - windows_maintenance_window.hour is number
      - windows_maintenance_window.duration is number
    fail_msg: >
      "Make sure windows_maintenance_window (mapping) variable exists and has day_of_week (string), hour (number) and duration (number) properties set"
    quiet: true

- name: Install Disk Cleanup script
  ansible.windows.win_template:
    src: DiskCleanup.ps1.j2
    dest: C:\Program Files\WindowsPowerShell\Scripts\DiskCleanup.ps1

- name: Schedule Cleanup Script
  community.windows.win_scheduled_task:
    name: Weekly Windows Disk Cleanup script
    path: Naturalis
    description: Runs the weekly Disk Cleanup script
    actions:
      - path: C:\Windows\System32\WindowsPowerShell\v1.0\powershell.exe
        arguments: -ExecutionPolicy ByPass -Command "& 'C:\Program Files\WindowsPowerShell\Scripts\DiskCleanup.ps1' -ClearPostponeFlag -Force"
    triggers:
      - type: weekly
        days_of_week: "{{windows_maintenance_window.day_of_week | replace('saturday','sunday')| replace('friday','saturday') | replace ('thursday','friday')| replace ('wednesday','thursday') | replace('tuesday','wednesday') | replace('monday','tuesday') }}"
        start_boundary: '2022-01-01T{{ "%02d" | format(windows_maintenance_window.hour) }}:00:00'
    username: SYSTEM
    run_level: highest
    state: present
...
